def fn check_allgood%(square%)
rem square is the square we just put allgood on. Now we check to see whether
rem this will make a row of five
rem this function returns nbr of squares emptied if row of fiver,else 0
local found%
  found%=check_allgood_up_down%(square%)
  if found% : ret found%
  found%= check_allgood_left_right%(square%)
  if found% : ret found%
  found%=check_allgood_left_up%(square%)
  if found% : ret found%
  found%= check_allgood_right_up%(square%)
  if found% : ret found%
  ret 0
end def check_allgood
:
def fn check_allgood_up_down% (squarep%)
rem this checks when an allgood stone was put into a square, whether a
rem fiver row exists up or down
local found%,lp%,sq%,at_end%,square%,target%
rem up first
rem we go up from the current square until we get to the edge or find a
rem square that isn't an allgood one, then do an up_down on that:
rem then same down
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%-rows%			: rem next row up
    if sq%<1:at_end%=1:exit lp% 	: rem was in last row already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,1)
     if found%:return found%
  end if
rem now down
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%+rows%			: rem next column right
    if sq% > stopsquare%:at_end%=1:exit lp% : rem was in last row already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,1)
     if found%:return found%
  end if
  ret 0 				: rem nothing found
end def check_allgood_up_down%
:
def fn check_allgood_left_right% (squarep%)
rem this checks when an allgood stone was put into a square, whether a
rem fiver row exists left or right.
local found%,lp%,sq%,at_end%,square%,target%
rem left first
rem we go left from the current square until we get to the edge or find a
rem square that isn't an allgood one, then do a left-right on that:
rem then same to right
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%-1				: rem next column left
    if (sq% mod rows%)=0:at_end%=1:exit lp% : rem was in last col already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,2)
     if found%:return found%
  end if
rem now to the right
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%+1				: rem next column right
    if (sq% mod rows%)=1:at_end%=1:exit lp% : rem was in last col already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,2)
     if found%:return found%
  end if
  ret 0 				: rem nothing found
end def check_allgood_left_right%
:
def fn check_allgood_left_up% (squarep%)
rem this checks when an allgood stone was put into a square, whether a
rem fiver row exists
local found%,lp%,sq%,at_end%,square%,target%
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%-1-rows%			  : rem next column up,left
    if (sq% mod rows%)=0:at_end%=1:exit lp% : rem was in last col already
    if sq%<1:at_end%=1:exit lp%
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,4)
     if found%:return found%
  end if
rem now to the right
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%+1+rows%			: rem next column right,down
    if (sq% mod rows%)=1:at_end%=1:exit lp% : rem was in last col already
    if sq% > stopsquare%:at_end%=1:exit lp% : rem was in last col already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,4)
     if found%:return found%
  end if
  ret 0 				: rem nothing found
end def check_allgood_left_up%
:
def fn check_allgood_right_up% (squarep%)
rem this checks when an allgood stone was put into a square, whether a
rem fiver row exists left or right.
local found%,lp%,sq%,at_end%,square%,target%
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%+1-rows%			: rem next right up
    if (sq% mod rows%)=1:at_end%=1:exit lp% : rem was in last col already
    if sq%<1:at_end%=1:exit lp% 	: rem was in last col already
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,8)
     if found%:return found%
  end if
rem now to the right
  sq%=squarep%
  at_end%=0
  rep lp%
    sq%=sq%-1+rows%			: rem next column right
    if (sq% mod rows%)=0:at_end%=1:exit lp% : rem was in last col already
    if sq% > stopsquare%:at_end%=1:exit lp%
    if squares%(sq%)=0::at_end%=1:exit lp% : rem empty - like last row
    if squares%(sq%)<>allgood% :exit lp%
  end rep lp%
rem now sq% is either one past the edge or the new target
  if not at_end%
     found%=check_if_fiver%(sq%,8)
     if found%:return found%
  end if
  ret 0 				: rem nothing found
end def check_allgood_right_up%
:
 
