def fn make_highscore_watermark (chan%)
rem this returns the watermark
local lp%,wm1,count%,a%
  wm1=waterm				: rem this will be my calculated watermark
  count%=0
  rep lp%
    if eof(#chan%):exit lp%		: rem end
    bget#chan%,a%			: rem get a byte
    count%=count%+1
    if count%=7
      wm1=wm1-a%			: rem make simple watermark
      count%=0
    else
      wm1=wm1+a%			: rem just to confuse everybody
    endif
  end rep lp%
  return wm1
end def make_highscore_watermark
:
def proc load_highscore_table
rem load the highscore file into arrays
local lp%,a$,a%,chan%,wm11,wm1
  if highscorefile$="":return		: rem there is no highscore file
  chan%=fop_in(highscorefile$)		: rem try to open it
  if chan%<0:return			: rem no success in opening it
  if eof(#chan%):return 		: rem nothing yet
  get#chan%,wm11			: rem number
  wm1=make_highscore_watermark(chan%)
  if wm1<>wm11
    a%=warning% ("This highscore file seems to have been tampered with! It is rejected",0,highscorefile$)
    highscorefile$=""
    close #chan%
    return				: rem this file has been fiddled with
  endif
  get#chan%\0
  get#chan%,wm11			: rem watermark
  input#chan%,a$
  if a$<>waterm$:close#chan%:return	: rem this is no highscore file
  get#chan%,hiscorenbr% 		: rem nbr of current highscores
  if not hiscorenbr%:close#chan%:return : rem huh?
  dim hinames$(hiscorenbr%,75)
  hinames$(0)="SCORE NAME                           DATE & TIME"
  for lp%=1 to hiscorenbr%
    input#chan%,hinames$(lp%)
  end for lp%
  close#chan%
end def load_highscore_table
:
def proc save_highscore_table
local chan%,wm11,lp%
  if not hiscorenbr%:return		: rem there is no highscore (!)
  if highscorefile$="":return		: rem there is no highscore file
  chan%=fop_over(highscorefile$)	: rem try to open it
  if chan%<0:return			: rem no success in opening it
  wm11=waterm
  put#chan%,wm11			: rem simple place holder right now
  print#chan%,waterm$			: rem this is indeed a highscore file
  put#chan%,hiscorenbr% 		: rem nbr of highscore entries
  for lp%=1 to hiscorenbr%
    print#chan%,hinames$(lp%)		: rem name of high scorer
  end for lp%
  get#chan%\0				: rem back at beginning of file
  get#chan%,wm11			: rem set file pointer for next operation
  wm11=make_highscore_watermark(chan%)	: rem make watermark
  get#chan%\0				: rem back at beginning of file
  put#chan%,wm11			: rem save watermark
  close#chan%				: rem close channel
end def save_highscore_table
:
