def proc new_seed
rem This sets the new seed for 3 new balls.
rem It checks whether we have too many jokers on the field, if yes, the new
rem seed will not be a joker
local lp%,t%,lp2%
  for lp%=0 to 2
    t%=rnd(1 to game_type%)		: rem get a new ball
    if t%=allgood%
      if tot_allgood%=max_allgood%
	rep lp2%
	  if t%<>allgood%:exit lp2%	: rem was allgood, and we exceeded max algoods
	  t%=rnd(1 to game_type%)	: rem get a new ball
	end rep lp2%
      else
	tot_allgood%=tot_allgood%+1	: rem one more joker
      end if
     endif
    seed%(lp%)=t%			: rem put new ball in
  end for lp%
end def new_seed
:
def fn set_new% (item%)
rem This finds a new empty square, sets this to seed (item%) and draws it.
rem If it can't find an empty square, in a reasonable time, it looks for the
rem next empty square from the beginning.
rem This returns -1 of there is no epmty square any more (you lost),
rem else an arbitray value
local lp%,t%
  for lp%=1 to stopsquare%*2
    t%=rnd(1 to stopsquare%)		: rem could be this square
    if squares%(t%)=0:exit lp%		: rem it is!
    t%=-1				: rem square isn't empty
  end for lp%
  if t%=-1
				rem we get here if we couldn't find an empty square
    for lp%=1 to stopsquare%
       if squares%(lp%)=0:t%=lp%:exit lp% : rem found an empty one
    end for lp%
    if t%=-1:you_lost:ret t%		: rem there is no empty square!
  endif
  squares%(t%)=seed%(item%)		: rem set this square to this ball
  print_sprite t%,0			: rem and draw it
  ret t%
end def set_new%
:
def proc you_lost
local dummy
  beep_end				: rem make you lost sound
  dummy=item_select ('YOU LOST!',"Yup, once again...","OK") : rem print it, too
  make_new_highscore_entry		: rem possible new highsocre entry now
end def you_lost
:
